unit UnidadMenuPrincipal;

{$R WinXP.res}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shellapi, winsvc, ExtCtrls, ComCtrls, ThemeMgr, inifiles;

type
  TformMenuPrincipal = class(TForm)
    bDesactivarCortafuegos: TButton;
    GroupBox1: TGroupBox;
    lEstado: TLabel;
    bIniciar: TButton;
    Label1: TLabel;
    lInfo: TStaticText;
    Shape1: TShape;
    bActualizar: TButton;
    bSalir: TButton;
    be: TStatusBar;
    Label2: TLabel;
    txtNombreServicio: TEdit;
    ThemeManager1: TThemeManager;
    procedure bDesactivarCortafuegosClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure estadoCortafuegos ();
    procedure bActualizarClick(Sender: TObject);
    procedure bSalirClick(Sender: TObject);
    procedure bIniciarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    nombreServicio : string;    

  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

// Inicia un servicio de Windows
function iniciarServicio (equipo, servicio : string) : Boolean;
var
  schm,
  schs: SC_Handle;
  ss: TServiceStatus;
  psTemp: PChar;
  dwChkP: DWord;
begin
  ss.dwCurrentState := 0;
  schm := OpenSCManager(PChar(equipo), nil, SC_MANAGER_CONNECT);
  if (schm > 0) then
  begin
    schs := OpenService(schm, PChar(servicio), SERVICE_START or
      SERVICE_QUERY_STATUS);
    if (schs > 0) then
    begin
      psTemp := nil;
      if (StartService(schs, 0, psTemp)) then
        if (QueryServiceStatus(schs, ss)) then
          while (SERVICE_RUNNING <> ss.dwCurrentState) do
          begin
            dwChkP := ss.dwCheckPoint;
            Sleep(ss.dwWaitHint);
            if (not QueryServiceStatus(schs, ss)) then
              Break;
            if (ss.dwCheckPoint < dwChkP) then
              Break;
          end;
      CloseServiceHandle(schs);
    end;
    CloseServiceHandle(schm);
  end;
  Result := SERVICE_RUNNING = ss.dwCurrentState;
end;

// Detiene un servicio de Windows
function detenerServicio (equipo, servicio : String) : Boolean;
var
  schm,
  schs: SC_Handle;
  ss: TServiceStatus;
  dwChkP: DWord;
begin
  schm := OpenSCManager(PChar(equipo), nil, SC_MANAGER_CONNECT);
  if (schm>0) then
  begin
    schs := OpenService(schm, PChar(servicio), SERVICE_STOP or
      SERVICE_QUERY_STATUS);
    if (schs>0) then
    begin
      if (ControlService(schs, SERVICE_CONTROL_STOP, ss)) then
        if (QueryServiceStatus(schs, ss)) then
          while (SERVICE_STOPPED<>ss.dwCurrentState) do
          begin
            dwChkP := ss.dwCheckPoint;
            Sleep(ss.dwWaitHint);
            if (not QueryServiceStatus(schs, ss)) then
              Break;
            if (ss.dwCheckPoint < dwChkP) then
              Break;
          end;
      CloseServiceHandle(schs);
    end;
    CloseServiceHandle(schm);
  end;
  Result := SERVICE_STOPPED=ss.dwCurrentState;
end;



// Obtiene el estado de un servicio
function estadoServicio(sPC, sServicio : string ) : string;
var
  schm, schs   : SC_Handle;
  ss     : TServiceStatus;
  dwStat : DWord;
begin
  dwStat := 0;
  schm := OpenSCManager(PChar(sPC), Nil, SC_MANAGER_CONNECT);
  if (schm > 0) then
  begin
    schs := OpenService(schm, PChar(sServicio), SERVICE_QUERY_STATUS);
    if (schs > 0) then
    begin
      if (QueryServiceStatus(schs, ss)) then
      begin
        dwStat := ss.dwCurrentState;
      end;
      CloseServiceHandle(schs);
    end;
    CloseServiceHandle(schm);
  end;
  case dwStat of
    0 : Result := 'No disponible';
    1 : Result := 'Detenido';
    2 : Result := 'Iniciando';
    3 : Result := 'Deteniendo';
    4 : Result := 'Iniciado';
    7 : Result := 'Pausado';
  else
    result := inttostr(dwstat);
  end;
end;

// Lee una cadena de texto de un INI
function leCadINI (clave, cadena : string; defecto : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readString (clave, cadena, defecto);
  finally
    free;
  end;
end;

//escribe una cadena de texto en un INI
procedure esCadINI (clave, cadena, valor : string);
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writeString (clave, cadena, valor);
  finally
    free;
  end;
end;

procedure TformMenuPrincipal.estadoCortafuegos ();
begin
  lEstado.Caption := estadoServicio('', txtNombreServicio.Text);
  if (lEstado.Caption = 'Detenido') or (lEstado.Caption = 'Pausado') or
     (lEstado.Caption = 'No disponible') then
  begin
    lInfo.Caption := 'Antecin: el cortafuegos (firewall) de Windows est ' +
        'detenido, si no tiene un antivirus o cortafuegos actvelo para evitar ' +
        'posibles intrusiones de virus y dems.';
    lInfo.Font.Color := clMaroon;
    bIniciar.Enabled := true;
    bDesactivarCortafuegos.Enabled := false;
  end
  else
  begin
    lInfo.Caption := 'El cortafuegos (firewall) de Windows est ' +
        'iniciado.';
    lInfo.Font.Color := clGreen;
    bIniciar.Enabled := false;
    bDesactivarCortafuegos.Enabled := true;
  end;
end;

procedure TformMenuPrincipal.bDesactivarCortafuegosClick(Sender: TObject);
begin
  nombreServicio := txtNombreServicio.Text;
  Cursor := crHourGlass;
  be.Panels[0].Text := 'Deteniendo servicio ' + nombreServicio + ', espere por favor';
  be.Refresh;
  bActualizar.Enabled := false;
  bIniciar.Enabled := false;
  bSalir.Enabled := false;
  bDesactivarCortafuegos.Enabled := false;
  if detenerServicio ('', nombreServicio) then
    be.Panels[0].Text := 'Servicio ' + nombreServicio + ' detenido'
  else
    be.Panels[0].Text := 'Error al detener el servicio ' + nombreServicio;
  bActualizarClick(Self);
  bSalir.Enabled := true;
  bActualizar.Enabled := true;
  Cursor := crDefault;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  parametro1, parametro2 : string;
begin
  txtNombreServicio.Text := leCadINI('Configuracin', 'Nombre servicio', 'SharedAccess');
  if ParamCount >= 1 then
  begin
    parametro1 := ParamStr(1);
    parametro2 := ParamStr(2);
    if (AnsiUpperCase (parametro1) = 'I') or
        (AnsiUpperCase (parametro1) = '-I') or
        (AnsiUpperCase (parametro1) = '/I') then
      bIniciarClick(Self);
    if (AnsiUpperCase (parametro1) = 'D') or
        (AnsiUpperCase (parametro1) = '-D') or
        (AnsiUpperCase (parametro1) = '/D') then
      bDesactivarCortafuegosClick(Self);
    if (AnsiUpperCase (parametro2) = 'C') or
        (AnsiUpperCase (parametro2) = '-C') or
        (AnsiUpperCase (parametro2) = '/C') then
    begin
      Application.Terminate;
      Close;
    end;
  end;
  estadoCortafuegos();
end;

procedure TformMenuPrincipal.bActualizarClick(Sender: TObject);
begin
  nombreServicio := txtNombreServicio.Text;
  estadoCortafuegos ();
end;

procedure TformMenuPrincipal.bSalirClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.bIniciarClick(Sender: TObject);
begin
  nombreServicio := txtNombreServicio.Text;
  Cursor := crHourGlass;
  be.Panels[0].Text := 'Iniciando servicio ' + nombreServicio + ', espere por favor';
  be.Refresh;
  bActualizar.Enabled := false;
  bIniciar.Enabled := false;
  bSalir.Enabled := false;
  bDesactivarCortafuegos.Enabled := false;
  if iniciarServicio('', nombreServicio) then
    be.Panels[0].Text := 'Servicio iniciado'
  else
    be.Panels[0].Text := 'Error al iniciar servicio';
  bActualizarClick(Self);
  bSalir.Enabled := true;
  bActualizar.Enabled := true;
  Cursor := crDefault;
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  esCadINI('Configuracin', 'Nombre servicio', txtNombreServicio.Text);
end;

end.
